SystemOrganization addCategory: #'GT-Inspector'!

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 11:11'!
gtInspectorEvaluatorIn: composite
	<gtInspectorPresentationOrder: 100>
	(composite text)
		forSmalltalk;
		display: [ :entity | 'self' ];
		title: 'Evaluator';
		selectionPopulate: #selection
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text :entity | Compiler evaluate: text selectedText for: entity logged: false ];
		selectionAct: [ :text :entity | Compiler evaluate: text selectedText for: entity logged: false ]
			on: $d
			entitled: 'Do it (d)';
		selectionAct: [ :text :entity | (Compiler evaluate: text selectedText for: entity logged: false) inspect ]
			on: $i
			entitled: 'Inspect (i)';
		selectionAct: [ :text :entity | (Compiler evaluate: text selectedText for: entity logged: false) explore ]
			on: $I
			entitled: 'Explore (I)'! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:05'!
gtInspectorMethodsIn: composite
	<gtInspectorPresentationOrder: 50>
	composite custom: (GTSimpleMethodsBrowser new browser startOn: self) ! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:06'!
gtInspectorPresentationsIn: composite
	| pragmas |
	pragmas := Pragma 
				allNamed: #gtInspectorPresentationOrder: 
				from: self class 
				to: Object 
				sortedUsing: [: x :y | (x argumentAt: 1) < (y argumentAt: 1)].
	pragmas do: [ :eachPragma | 
		self perform: eachPragma selector with: composite ]
! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 11:59'!
gtInspectorRetrieveVariableValuePairs
	"This is a helper method that returns a collection of variable names -> value for the current object.
	Subclasses can override it to specialize what appears in the variables presentation"
	^ (OrderedCollection new)
		add: '_self' -> self;
		addAll: (self class allInstVarNames collect: [ :iv | iv -> (self instVarNamed: iv) ]);
		yourself! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 10:12'!
gtInspectorVariablesIn: composite
	<gtInspectorPresentationOrder: 10>
	composite table
		title: 'Variables';
		showOnly: 50;
		display: [ :anObject | self gtInspectorRetrieveVariableValuePairs ];
		sorted: [:assoc1 :assoc2 | assoc1 key < assoc2 key];
		column: 'Variable' evaluated: [:assoc | 
			[ Text fromString: assoc key asString ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
		column: 'Value' evaluated: [:assoc | 
			[ Text fromString: (assoc value printString contractTo: 50) ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
		icon: [ :each | 
			each value class theNonMetaClass browserIcon
				ifNotNil: [ OBMorphicIcons iconNamed: each value class theNonMetaClass browserIcon ] ];
		send: #value;
		morphicSelectionAct: [:each | each value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse'! !

!Dictionary methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:12'!
gtInspectorRetrieveVariableValuePairs  
	^ OrderedCollection new 
		add: ( 'self' -> self); 
		add: ( 'tally' -> self size );
		add: ( 'array' -> self array );
		yourself
! !

!ByteArray methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 11:52'!
gtInspectorItemsIn: composite! !

!String methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:19'!
gtInspectorItemsIn: composite
	"We do not offer the list of items for a String"! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:12'!
gtInspectorRetrieveVariableValuePairs
	| literalIndex |
	literalIndex := 0.
	^ OrderedCollection new 
		add: ( 'self' -> self); 
		add: ( 'header' -> self headerDescription );
		addAll: ( self literals collect: [ :aLiteral | 'literal', ( literalIndex := literalIndex + 1 ) asString -> aLiteral ] );
		add: ( 'all bytecodes' -> self symbolic );
		yourself
! !

!Morph methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:05'!
gtInspectorMorphIn: composite
	<gtInspectorPresentationOrder: 90>  
	composite morph title: 'Morph'! !

!Bitmap methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 11:49'!
gtInspectorItemsIn: composite
	"No items presentation for a Bitmap"! !

!Form methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:05'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 90>  
	composite morph 
		title: 'Morph';
		display: [:object | object asMorph]! !

!ContextPart methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:12'!
gtInspectorRetrieveVariableValuePairs
	| tempIndex |
	tempIndex := 0.
	^ super gtInspectorRetrieveVariableValuePairs
		addAll:
				(self tempNames
						collect: [ :tempName | ('[' , tempName , ']') -> (self debuggerMap namedTempAt: (tempIndex := tempIndex + 1) in: self) ]);
		yourself! !

!Collection methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 11:03'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 30>  
	 (composite list)
		beMultiple;
		title: [ :anObject | anObject size asString, ' items' ];
		searchOn: [:text :each | 
			Compiler evaluate: ' | entity each | each := self. entity := each.', text for: each logged: false];		
		format: [ :each |
			[ Text fromString: ((each asString contractTo: 50) replaceAll: String cr with: String space) ] 
							on: Error 
							do: [ Text string: 'error printing' attribute: TextColor red ] ];
		send: [ :result | result size = 1 ifTrue: [result anyOne] ifFalse: [result]];
		icon: [ :each |  
			| iconName |
			iconName := each class theNonMetaClass browserIcon ifNil: [#blank].
			OBMorphicIcons iconNamed: iconName ];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

GLMBrowserTemplate subclass: #GTInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspector commentStamp: 'TudorGirba 8/21/2011 16:57' prior: 0!
This is meant to be used for inspecting objects. It offers multiple views and it uses a finder as a navigation. One particular feature is that you can use the evaluator tab to enter code, and evaluating it results in opening another pane to the right.

The object finder asks dynamically the object for the actual presentations that are displayed in each pane.

Example:
self openOn: Smalltalk.

Register it as a replacement for explorer:
self registerToolsOn: Smalltalk tools.!

!GTInspector classSide methodsFor: 'tools registry' stamp: 'TudorGirba 8/21/2011 16:57'!
registerToolsOn: registry
	"self registerToolsOn: Smalltalk tools " 
	registry register: self as: #objectExplorer
! !

!GTInspector methodsFor: 'building' stamp: 'TudorGirba 8/22/2011 10:01'!
buildBrowser
	browser := GLMFinder new.
	browser title: [:anObject | 'Inspector on ', (self printObjectAsAnItem: anObject)].
	browser show: [ :a | 
		a title: [ :anObject | self printObjectAsAnItem: anObject ].
		a 
			morphicAct: [:composite | composite entity browse]
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			entitled: 'Browse'.
		a dynamic 
			display: [:each | 
				| dynamic |
				dynamic := GLMCompositePresentation new.
				each gtInspectorPresentationsIn: dynamic.
				dynamic ] ].
	^ browser! !

!GTInspector methodsFor: 'opening' stamp: 'TudorGirba 8/21/2011 08:56'!
openExplorerFor: anObject
	"this method is needed for compatibility with ObjectExplorer"
	self openOn: anObject! !

!GTInspector methodsFor: 'private' stamp: 'TudorGirba 8/22/2011 11:05'!
printObjectAsAnItem: anObject 
	| title stream previewString |
	stream := String new writeStream.
	title := anObject class name.
	stream
		nextPutAll: (title first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: title.
	previewString := [ Text fromString: (anObject printString contractTo: 10) ]
						on: Error
						do: [ 'error printing' ].
	stream 
		nextPutAll: ' (';
		nextPutAll: previewString;
		nextPut: $).
	^ stream contents! !
